installer_version=0.0.1
kernel_dir=/usr/src/linux
bin_dir=/usr/bin

echo "Kernel Socks Bouncer for 2.6.x kernels Installer v$installer_version"
echo ""

# Checking all components of KSB26
echo "Checking components of KSB26:"
if [ ! -d kernel ] || [ ! user ] ; then
	echo "Cannot find subdirectoryes containing components of KSB26"
	exit -1
fi
echo -n "kernel/ksb26.patch -> "
if [ ! -e kernel/ksb26.patch ] ; then
	echo "not found!"
	exit -1
else
	echo "found!"
fi
echo -n "kernel/ksb26lkm.c -> "
if [ ! -e kernel/ksb26lkm.c ] ; then
	echo "not found!"
	exit -1
else
	echo "found!"
fi
echo -n "user/ksb26manager -> "
if [ ! -e user/ksb26manager ] ; then
	echo "not found!"
	exit -1
else
	echo "found!"
fi

# Checking Linux kernel source directory
if [ ! -d $kernel_dir ] || [ ! $kernel_dir/net ] || [ ! $kernel_dir/include ]  || [ ! $kernel_dir/kernel ] ; then
	echo "Cannot find Linux Kernel source in $kernel_dir"
	echo "Please edit this script and set 'kernel_dir' to the correct value'"
	exit -1
fi

# Starting installation
echo "Patching Linux kernel source"
cp kernel/ksb26.patch $kernel_dir
if [ ! -e $kernel_dir/ksb26.patch ] ; then
	exit -1
fi
patch -d $kernel_dir -b -p0 < kernel/ksb26.patch
if [ ! -e $kernel_dir/net/ksb26.c ] ; then
	echo "Failed to patch Linux kernel source"
	exit -1
fi
echo "Building kernel/ksb26lkm.c"
make -C /usr/src/linux/ SUBDIRS=$PWD/kernel V=1 modules
if [ ! -e kernel/ksb26lkm.ko ] ; then
	exit -1
fi
echo "Installing kernel/ksb26lkm.ko"
make -C /usr/src/linux/ SUBDIRS=$PWD/kernel V=1 modules_install
depmod
echo "Installing user/ksb26manager"
cp user/ksb26manager $bin_dir
if [ ! -e $bin_dir/ksb26manager ] ; then
	exit -1
fi
echo "Done"
echo ""
echo "Now you have to :"
echo "* rebuild your Linux Kernel patched with KSB26 [simply run 'make' command in $kernel_dir directory]"
echo "* modify your boot loader configuration file [read README]"
echo "* reboot"
echo "* read README for informations about the use of KSB26"
